
package net.mcreator.metroidmadness.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.metroidmadness.world.inventory.PlanetPickerMenu;
import net.mcreator.metroidmadness.network.PlanetPickerButtonMessage;
import net.mcreator.metroidmadness.MetroidMadnessMod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class PlanetPickerScreen extends AbstractContainerScreen<PlanetPickerMenu> {
	private final static HashMap<String, Object> guistate = PlanetPickerMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;

	public PlanetPickerScreen(PlanetPickerMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 425;
		this.imageHeight = 235;
	}

	@Override
	public boolean isPauseScreen() {
		return true;
	}

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();

		RenderSystem.setShaderTexture(0, new ResourceLocation("metroid_madness:textures/screens/map.png"));
		this.blit(ms, this.leftPos + 0, this.topPos + 0, 0, 0, 425, 235, 425, 235);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		this.addRenderableWidget(new Button(this.leftPos + 180, this.topPos + 87, 51, 20, new TextComponent("Zebes"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 168, this.topPos + 125, 51, 20, new TextComponent("SR388"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 111, this.topPos + 59, 72, 20, new TextComponent("Tallon IV"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 219, this.topPos + 180, 56, 20, new TextComponent("Aether"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 72, this.topPos + 92, 56, 20, new TextComponent("Phaaze"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 238, this.topPos + 7, 40, 20, new TextComponent("ZDR"), e -> {
			if (true) {
				MetroidMadnessMod.PACKET_HANDLER.sendToServer(new PlanetPickerButtonMessage(5, x, y, z));
				PlanetPickerButtonMessage.handleButtonAction(entity, 5, x, y, z);
			}
		}));
		this.addRenderableWidget(new Button(this.leftPos + 235, this.topPos + 151, 82, 20, new TextComponent("Dark Aether"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 311, this.topPos + 103, 93, 20, new TextComponent("B.S.L Station"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 311, this.topPos + 197, 82, 20, new TextComponent("BOTTLE SHIP"), e -> {
		}));
		this.addRenderableWidget(new Button(this.leftPos + 49, this.topPos + 181, 51, 20, new TextComponent("Earth"), e -> {
			if (true) {
				MetroidMadnessMod.PACKET_HANDLER.sendToServer(new PlanetPickerButtonMessage(9, x, y, z));
				PlanetPickerButtonMessage.handleButtonAction(entity, 9, x, y, z);
			}
		}));
	}
}
