package net.mcreator.metroidmadness.client.model;

import net.minecraft.world.entity.Entity;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.model.geom.builders.PartDefinition;
import net.minecraft.client.model.geom.builders.MeshDefinition;
import net.minecraft.client.model.geom.builders.LayerDefinition;
import net.minecraft.client.model.geom.builders.CubeListBuilder;
import net.minecraft.client.model.geom.builders.CubeDeformation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.ModelPart;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.EntityModel;

import com.mojang.blaze3d.vertex.VertexConsumer;
import com.mojang.blaze3d.vertex.PoseStack;

// Made with Blockbench 4.4.3
// Exported for Minecraft version 1.17 - 1.18 with Mojang mappings
// Paste this class into your mod and generate all required imports
public class ModelCorpius<T extends Entity> extends EntityModel<T> {
	// This layer location should be baked with EntityRendererProvider.Context in
	// the entity renderer and passed into this model's constructor
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(new ResourceLocation("metroid_madness", "model_corpius"), "main");
	public final ModelPart neck;
	public final ModelPart head;
	public final ModelPart body;
	public final ModelPart rearleg;
	public final ModelPart rearleg2;
	public final ModelPart tail;

	public ModelCorpius(ModelPart root) {
		this.neck = root.getChild("neck");
		this.head = root.getChild("head");
		this.body = root.getChild("body");
		this.rearleg = root.getChild("rearleg");
		this.rearleg2 = root.getChild("rearleg2");
		this.tail = root.getChild("tail");
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();
		PartDefinition neck = partdefinition.addOrReplaceChild("neck",
				CubeListBuilder.create().texOffs(92, 0).addBox(-11.0F, -12.0F, -18.0F, 22.0F, 22.0F, 19.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -30.0F, -8.0F));
		PartDefinition head = partdefinition.addOrReplaceChild("head",
				CubeListBuilder.create().texOffs(120, 52).addBox(-9.0F, -11.0F, -13.0F, 19.0F, 19.0F, 16.0F, new CubeDeformation(0.0F))
						.texOffs(48, 145).addBox(-9.0F, -10.0F, -28.0F, 19.0F, 8.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, -30.0F, -27.0F));
		PartDefinition jaw = head.addOrReplaceChild("jaw",
				CubeListBuilder.create().texOffs(142, 87).addBox(-9.0F, -6.0F, -13.0F, 19.0F, 9.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offset(0.0F, 4.0F, -15.0F));
		PartDefinition body = partdefinition.addOrReplaceChild("body",
				CubeListBuilder.create().texOffs(0, 0).addBox(-12.0F, 0.0F, -16.0F, 24.0F, 24.0F, 44.0F, new CubeDeformation(0.0F)).texOffs(0, 68)
						.addBox(-12.0F, 0.0F, 27.0F, 24.0F, 14.0F, 31.0F, new CubeDeformation(0.0F)).texOffs(64, 113)
						.addBox(19.0F, 28.0F, 27.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(88, 199)
						.addBox(19.0F, 28.0F, 36.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(120, 201)
						.addBox(19.0F, 28.0F, 45.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(120, 201)
						.addBox(19.0F, 28.0F, 53.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(64, 113).mirror()
						.addBox(-23.0F, 28.0F, 27.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).mirror(false).texOffs(88, 199).mirror()
						.addBox(-23.0F, 28.0F, 36.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).mirror(false).texOffs(120, 201).mirror()
						.addBox(-23.0F, 28.0F, 45.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).mirror(false).texOffs(120, 201).mirror()
						.addBox(-23.0F, 28.0F, 53.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).mirror(false),
				PartPose.offset(0.0F, -43.0F, 8.0F));
		PartDefinition body_r1 = body.addOrReplaceChild("body_r1",
				CubeListBuilder.create().texOffs(104, 201).mirror().addBox(-2.0F, -3.0F, -2.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F))
						.mirror(false).texOffs(104, 201).mirror().addBox(-2.0F, -3.0F, -10.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F))
						.mirror(false).texOffs(88, 169).mirror().addBox(-2.0F, -3.0F, -19.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F))
						.mirror(false).texOffs(0, 68).mirror().addBox(-2.0F, -3.0F, -28.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F))
						.mirror(false),
				PartPose.offsetAndRotation(-13.0F, 8.0F, 55.0F, 0.0F, 0.0F, 0.3491F));
		PartDefinition body_r2 = body.addOrReplaceChild("body_r2",
				CubeListBuilder.create().texOffs(104, 201).addBox(-2.0F, -3.0F, -2.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(104, 201)
						.addBox(-2.0F, -3.0F, -10.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(88, 169)
						.addBox(-2.0F, -3.0F, -19.0F, 4.0F, 26.0F, 4.0F, new CubeDeformation(0.0F)).texOffs(0, 68).addBox(-2.0F, -3.0F, -28.0F, 4.0F,
								26.0F, 4.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(13.0F, 8.0F, 55.0F, 0.0F, 0.0F, -0.3491F));
		PartDefinition rearleg = partdefinition.addOrReplaceChild("rearleg", CubeListBuilder.create(),
				PartPose.offsetAndRotation(-16.0F, -31.0F, 16.0F, 0.0F, 0.0F, 0.2618F));
		PartDefinition rearleg_r1 = rearleg.addOrReplaceChild("rearleg_r1",
				CubeListBuilder.create().texOffs(0, 113).addBox(-4.0F, -11.0F, -10.0F, 16.0F, 32.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -2.0F, 0.0F, 0.0F, 0.0F, 0.9599F));
		PartDefinition rearlegtip = rearleg.addOrReplaceChild("rearlegtip", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 28.0F, 1.0F, 0.4363F, 0.0F, 0.0F));
		PartDefinition rearlegtip_r1 = rearlegtip.addOrReplaceChild("rearlegtip_r1",
				CubeListBuilder.create().texOffs(0, 161).addBox(-6.0F, -2.0F, -8.0F, 12.0F, 32.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-17.0F, -16.0F, 6.0F, -0.4363F, 0.0F, 0.0F));
		PartDefinition rearfoot = rearlegtip.addOrReplaceChild("rearfoot", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 32.0F, -2.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition rearfoot_r1 = rearfoot.addOrReplaceChild("rearfoot_r1",
				CubeListBuilder.create().texOffs(154, 161).addBox(-1.0F, -3.0F, -24.0F, 6.0F, 6.0F, 24.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(-19.0F, -17.0F, 12.0F, 0.3099F, -0.1664F, -0.053F));
		PartDefinition rearleg2 = partdefinition.addOrReplaceChild("rearleg2", CubeListBuilder.create(),
				PartPose.offsetAndRotation(16.0F, -31.0F, 14.0F, 0.0F, 0.0F, -0.2618F));
		PartDefinition rearleg_r2 = rearleg2.addOrReplaceChild("rearleg_r2",
				CubeListBuilder.create().texOffs(94, 97).addBox(-12.0F, -11.0F, -8.0F, 16.0F, 32.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -2.0F, 0.0F, 0.0F, 0.0F, -0.9599F));
		PartDefinition rearlegtip2 = rearleg2.addOrReplaceChild("rearlegtip2", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 28.0F, 1.0F, 0.4363F, 0.0F, 0.0F));
		PartDefinition rearlegtip_r2 = rearlegtip2.addOrReplaceChild("rearlegtip_r2",
				CubeListBuilder.create().texOffs(106, 157).addBox(-6.0F, -2.0F, -6.0F, 12.0F, 32.0F, 12.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(17.0F, -16.0F, 6.0F, -0.4363F, 0.0F, 0.0F));
		PartDefinition rearfoot2 = rearlegtip2.addOrReplaceChild("rearfoot2", CubeListBuilder.create(),
				PartPose.offsetAndRotation(0.0F, 32.0F, -2.0F, 0.7854F, 0.0F, 0.0F));
		PartDefinition rearfoot_r2 = rearfoot2.addOrReplaceChild("rearfoot_r2",
				CubeListBuilder.create().texOffs(150, 17).addBox(-5.0F, -3.0F, -22.0F, 6.0F, 6.0F, 24.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(19.0F, -17.0F, 12.0F, 0.3099F, 0.1664F, 0.053F));
		PartDefinition tail = partdefinition.addOrReplaceChild("tail",
				CubeListBuilder.create().texOffs(184, 191).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, -43.0F, 50.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail2 = tail.addOrReplaceChild("tail2",
				CubeListBuilder.create().texOffs(144, 191).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail3 = tail2.addOrReplaceChild("tail3",
				CubeListBuilder.create().texOffs(190, 161).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail4 = tail3.addOrReplaceChild("tail4",
				CubeListBuilder.create().texOffs(190, 112).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail5 = tail4.addOrReplaceChild("tail5",
				CubeListBuilder.create().texOffs(190, 67).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail6 = tail5.addOrReplaceChild("tail6",
				CubeListBuilder.create().texOffs(48, 189).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail7 = tail6.addOrReplaceChild("tail7",
				CubeListBuilder.create().texOffs(186, 20).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail8 = tail7.addOrReplaceChild("tail8",
				CubeListBuilder.create().texOffs(186, 0).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail9 = tail8.addOrReplaceChild("tail9",
				CubeListBuilder.create().texOffs(174, 47).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(142, 129)
						.addBox(-8.0F, -8.0F, -3.0F, 16.0F, 16.0F, 16.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail10 = tail9.addOrReplaceChild("tail10",
				CubeListBuilder.create().texOffs(48, 169).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail11 = tail10.addOrReplaceChild("tail11",
				CubeListBuilder.create().texOffs(0, 20).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		PartDefinition tail12 = tail11.addOrReplaceChild("tail12",
				CubeListBuilder.create().texOffs(0, 0).addBox(-5.0F, -5.0F, 0.0F, 10.0F, 10.0F, 10.0F, new CubeDeformation(0.0F)).texOffs(79, 68)
						.addBox(-3.0F, -3.0F, 8.0F, 6.0F, 6.0F, 20.0F, new CubeDeformation(0.0F)),
				PartPose.offsetAndRotation(0.0F, 0.0F, 10.0F, 0.3054F, 0.0F, 0.0F));
		return LayerDefinition.create(meshdefinition, 256, 256);
	}

	@Override
	public void setupAnim(T entity, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch) {
	}

	@Override
	public void renderToBuffer(PoseStack poseStack, VertexConsumer vertexConsumer, int packedLight, int packedOverlay, float red, float green,
			float blue, float alpha) {
		neck.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		head.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		body.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rearleg.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		rearleg2.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
		tail.render(poseStack, vertexConsumer, packedLight, packedOverlay, red, green, blue, alpha);
	}
}
