
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.metroidmadness.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.metroidmadness.entity.YellowXEntity;
import net.mcreator.metroidmadness.entity.SAXEntity;
import net.mcreator.metroidmadness.entity.RavenBeakEntity;
import net.mcreator.metroidmadness.entity.PurpleRidleyEntity;
import net.mcreator.metroidmadness.entity.KraidEntity;
import net.mcreator.metroidmadness.entity.GreenRidleyEntity;
import net.mcreator.metroidmadness.entity.CorpiusEntity;
import net.mcreator.metroidmadness.entity.ArmCannonEntity;
import net.mcreator.metroidmadness.MetroidMadnessMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class MetroidMadnessModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.ENTITIES, MetroidMadnessMod.MODID);
	public static final RegistryObject<EntityType<ArmCannonEntity>> ARM_CANNON = register("projectile_arm_cannon",
			EntityType.Builder.<ArmCannonEntity>of(ArmCannonEntity::new, MobCategory.MISC).setCustomClientFactory(ArmCannonEntity::new)
					.setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final RegistryObject<EntityType<KraidEntity>> KRAID = register("kraid",
			EntityType.Builder.<KraidEntity>of(KraidEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(KraidEntity::new).fireImmune().sized(5f, 5f));
	public static final RegistryObject<EntityType<PurpleRidleyEntity>> PURPLE_RIDLEY = register("purple_ridley",
			EntityType.Builder.<PurpleRidleyEntity>of(PurpleRidleyEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true)
					.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(PurpleRidleyEntity::new)

					.sized(5f, 5f));
	public static final RegistryObject<EntityType<GreenRidleyEntity>> GREEN_RIDLEY = register("green_ridley",
			EntityType.Builder.<GreenRidleyEntity>of(GreenRidleyEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true)
					.setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(GreenRidleyEntity::new)

					.sized(5f, 5f));
	public static final RegistryObject<EntityType<CorpiusEntity>> CORPIUS = register("corpius",
			EntityType.Builder.<CorpiusEntity>of(CorpiusEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(CorpiusEntity::new)

					.sized(5f, 5f));
	public static final RegistryObject<EntityType<RavenBeakEntity>> RAVEN_BEAK = register("raven_beak",
			EntityType.Builder.<RavenBeakEntity>of(RavenBeakEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(RavenBeakEntity::new)

					.sized(1f, 2f));
	public static final RegistryObject<EntityType<YellowXEntity>> YELLOW_X = register("yellow_x",
			EntityType.Builder.<YellowXEntity>of(YellowXEntity::new, MobCategory.AMBIENT).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(YellowXEntity::new)

					.sized(1f, 1f));
	public static final RegistryObject<EntityType<SAXEntity>> SAX = register("sax",
			EntityType.Builder.<SAXEntity>of(SAXEntity::new, MobCategory.MISC).setShouldReceiveVelocityUpdates(true).setTrackingRange(64)
					.setUpdateInterval(3).setCustomClientFactory(SAXEntity::new)

					.sized(1f, 2f));

	private static <T extends Entity> RegistryObject<EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			KraidEntity.init();
			PurpleRidleyEntity.init();
			GreenRidleyEntity.init();
			CorpiusEntity.init();
			RavenBeakEntity.init();
			YellowXEntity.init();
			SAXEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(KRAID.get(), KraidEntity.createAttributes().build());
		event.put(PURPLE_RIDLEY.get(), PurpleRidleyEntity.createAttributes().build());
		event.put(GREEN_RIDLEY.get(), GreenRidleyEntity.createAttributes().build());
		event.put(CORPIUS.get(), CorpiusEntity.createAttributes().build());
		event.put(RAVEN_BEAK.get(), RavenBeakEntity.createAttributes().build());
		event.put(YELLOW_X.get(), YellowXEntity.createAttributes().build());
		event.put(SAX.get(), SAXEntity.createAttributes().build());
	}
}
