
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.metroidmadness.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;

import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.Holder;

import net.mcreator.metroidmadness.world.features.ores.VariumOreFeature;
import net.mcreator.metroidmadness.world.features.ores.ShipControlsFeature;
import net.mcreator.metroidmadness.world.features.ores.Metroid_ScaleOreFeature;
import net.mcreator.metroidmadness.world.features.ores.GravitiumOreFeature;
import net.mcreator.metroidmadness.world.features.ores.ChozodiumOreFeature;
import net.mcreator.metroidmadness.MetroidMadnessMod;

import java.util.function.Supplier;
import java.util.Set;
import java.util.List;
import java.util.ArrayList;

@Mod.EventBusSubscriber
public class MetroidMadnessModFeatures {
	public static final DeferredRegister<Feature<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.FEATURES, MetroidMadnessMod.MODID);
	private static final List<FeatureRegistration> FEATURE_REGISTRATIONS = new ArrayList<>();
	public static final RegistryObject<Feature<?>> SHIP_CONTROLS = register("ship_controls", ShipControlsFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, ShipControlsFeature.GENERATE_BIOMES, ShipControlsFeature::placedFeature));
	public static final RegistryObject<Feature<?>> CHOZODIUM_ORE = register("chozodium_ore", ChozodiumOreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, ChozodiumOreFeature.GENERATE_BIOMES, ChozodiumOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> METROID_SCALE_ORE = register("metroid_scale_ore", Metroid_ScaleOreFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, Metroid_ScaleOreFeature.GENERATE_BIOMES,
					Metroid_ScaleOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> VARIUM_ORE = register("varium_ore", VariumOreFeature::feature,
			new FeatureRegistration(GenerationStep.Decoration.UNDERGROUND_ORES, VariumOreFeature.GENERATE_BIOMES, VariumOreFeature::placedFeature));
	public static final RegistryObject<Feature<?>> GRAVITIUM_ORE = register("gravitium_ore", GravitiumOreFeature::feature, new FeatureRegistration(
			GenerationStep.Decoration.UNDERGROUND_ORES, GravitiumOreFeature.GENERATE_BIOMES, GravitiumOreFeature::placedFeature));

	private static RegistryObject<Feature<?>> register(String registryname, Supplier<Feature<?>> feature, FeatureRegistration featureRegistration) {
		FEATURE_REGISTRATIONS.add(featureRegistration);
		return REGISTRY.register(registryname, feature);
	}

	@SubscribeEvent
	public static void addFeaturesToBiomes(BiomeLoadingEvent event) {
		for (FeatureRegistration registration : FEATURE_REGISTRATIONS) {
			if (registration.biomes() == null || registration.biomes().contains(event.getName()))
				event.getGeneration().getFeatures(registration.stage()).add(registration.placedFeature().get());
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			Supplier<Holder<PlacedFeature>> placedFeature) {
	}
}
