
package net.mcreator.metroidmadness.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.metroidmadness.init.MetroidMadnessModTabs;

public abstract class MetroidSuitItem extends ArmorItem {
	public MetroidSuitItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 1024;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{2, 5, 6, 2}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 100;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.EMPTY;
			}

			@Override
			public String getName() {
				return "metroid_suit";
			}

			@Override
			public float getToughness() {
				return 10f;
			}

			@Override
			public float getKnockbackResistance() {
				return 2f;
			}
		}, slot, properties);
	}

	public static class Helmet extends MetroidSuitItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(MetroidMadnessModTabs.TAB_METROID_MADNESS).fireResistant());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "metroid_madness:textures/models/armor/metroidsuit__layer_1.png";
		}
	}

	public static class Chestplate extends MetroidSuitItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(MetroidMadnessModTabs.TAB_METROID_MADNESS).fireResistant());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "metroid_madness:textures/models/armor/metroidsuit__layer_1.png";
		}
	}

	public static class Leggings extends MetroidSuitItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(MetroidMadnessModTabs.TAB_METROID_MADNESS).fireResistant());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "metroid_madness:textures/models/armor/metroidsuit__layer_2.png";
		}
	}

	public static class Boots extends MetroidSuitItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(MetroidMadnessModTabs.TAB_METROID_MADNESS).fireResistant());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "metroid_madness:textures/models/armor/metroidsuit__layer_1.png";
		}
	}
}
